/* cam curve drawing                                1997.1.10*/
/* lift[i][d2] : d1:curve, i=0-n:T, d2=0:Y(T) =1:V(T), =2:A(T) */
#include <math.h>
#include <stdio.h>
#include <dos.h>
#include <conio.h>
#include <graph.h>

char fname[9][32]={"curv0", "curv1", "curv2", "curv3", "curv4", "curv5",
                   "curv6", "curv7"};
float kx=200,ky=-200,kv=-80,ka=-25
     ,x00=200,y00=350,pai=3.141593e0,pai2=6.283185e0,pai4=1.256637e1,zero=0;
float th[201],lift[201][3],Ta,Sa,Va,Tb,Sb,Vb,dth,am,curve[5][201][3];
int n=96,d1,d2,dd[10],m;
float x,y,c1,c2;
char ch,ch2;
line(x1,y1,x2,y2,ch2) float x1,y1,x2,y2; int ch2;
  {int p1,q1,p2,q2;
   p1=x00+kx*x1;      p2=x00+kx*x2;
   if(ch2==0)  {q1=y00+ky*y1;     q2=y00+ky*y2;}
   if(ch2==1)  {q1=y00+kv*y1;     q2=y00+kv*y2;}
   if(ch2==2)  {q1=200+ka*y1;     q2=200+ka*y2;}
   _moveto(p1,q1);    _lineto(p2,q2);
  }
circle(x,y,r,ch2)     float x,y,r;  int ch2;
  {int p1,q1,p2,q2;
   p1=x00+kx*(x+r);   p2=x00+kx*(x-r);
   if(ch2==0)  {q1=y00+ky*(y+r);  q2=y00+ky*(y-r);}
   if(ch2==1)  {q1=y00+kv*y+ky*r; q2=y00+kv*y-ky*r;}
   if(ch2==2)  {q1=200+ka*y+ky*r; q2=200+ka*y-ky*r;}
   _ellipse(_GFILLINTERIOR,p1,q1,p2,q2);
  }
axis(d2)
  {line(0.,0.,1.5,0.,d2);       line(0.,0.,0.,1.2,d2);
   line(0.,1.,1.5,1.,d2);       line(1.,0.,1.,1.2,d2);
   line(0.,0.5,0.05,0.5,d2);    line(0.5,0.,0.5,0.05,d2);
  }
axisv(d2)
  {int i;
   line(0.,0.,1.5,0.,d2);    line(0.,0.,0.,4.2,d2);   line(1.,0.,1.,4.2,d2);
   line(0.5,0.,0.5,0.08,d2);
   for(i=1;i<=4;i++)   line(0.,1.*i,0.05,1.*i,d2);
  }
axisa(d2)
  {int i;
   line(0.,0.,1.5,0.,d2); line(0.,-6.2,0.,6.2,d2); line(1.,-6.2,1.,6.2,d2);
   line(0.5,0.,0.5,0.1,d2);
   for(i=-6;i<=6;i++)   line(0.,1.*i,0.05,1.*i,d2);
  }


/* ----------------------------------------------------------------------- */
F(ch,T,rr) int ch; float T,rr[];  /* rr[]=(Y,V,A) */
  {float H,t;
   if(ch==0)   /* parabolic  */
    {if(T<=0.5) {rr[0]=2*T*T;  rr[1]=4*T;   rr[2]=4;}
     if(0.5<T)  {rr[0]=T*(4-2*T)-1;  rr[1]=4*(1-T);  rr[2]=-4;}
    }
   if(ch==1)   /* sine */
    {rr[0]=0.5*(1-cos(pai*T));
     rr[1]=pai/2*sin(pai*T);  rr[2]=pai*pai/2*cos(pai*T);
    }
   if(ch==2)   /* cycloid */
    {rr[0]=(T-sin(pai2*T)/pai2);
     rr[1]= 1-cos(pai2*T);  rr[2]=pai2*sin(pai2*T);
    }
   if(ch==3)   /* modified trapezoid */
    {Ta=0.125;  am=1/(0.25-(1-2/pai)*Ta);
     if(T<=Ta)
       {H=am/pai4;
        rr[0]=H*(T-sin(pai4*T)/pai4);
        rr[1]=H*(1-cos(pai4*T));  rr[2]=am*sin(pai4*T);
       }
     if(Ta<T && T<=3*Ta)
        {c1=1/pai4;  c2=(1-2/pai)/(32*pai);
         rr[0]=am*((T-Ta)*(T-Ta)/2+c1*(T-Ta)+c2);
         rr[1]=am*((T-Ta)+c1);   rr[2]=am;
        }
     if(3*Ta<T && T<=5*Ta)
        {c1=0.5-(2-2/pai)/8; c2=0.125-(1-1/pai)/8+(2-2/pai)/64;
         rr[0]=am*(sin(pai4*(T-0.5))/(pai4*pai4)+c1*(T-0.5+Ta)+c2);
         rr[1]=am*(cos(pai4*(T-0.5))/pai4+c1);  rr[2]=-am*sin(pai4*(T-0.5));
        }
     if(5*Ta<T && T<=7*Ta)
        {t=1-T; c1=1/pai4; c2=(1-2/pai)/(32*pai);
         rr[0]=1-am*((t-Ta)*(t-Ta)/2+c1*(t-Ta)+c2);
         rr[1]=am*((t-Ta)+c1);   rr[2]=-am;
        }
     if(7*Ta<T)
       {H=am/pai4;  t=1-T;
        rr[0]=1-H*(t-sin(pai4*t)/pai4);
        rr[1]=H*(1-cos(pai4*t));  rr[2]=-am*sin(pai4*t);
       }
    }
   if(ch==4)   /* modified sine */
    {Ta=0.125;       am=1/(2*Ta/pai+(2-8*Ta)/(pai*pai));
     Va=2*Ta*am/pai; Sa=2*Ta*Ta*am/pai*(1-2/pai);
     if(T<=Ta)
       {rr[0]=Va*T-2*Ta*Va/pai*sin(pai*T/(2*Ta));
        rr[1]=Va*(1-cos(pai*T/(2*Ta)));
        rr[2]=am*sin(pai*T/(2*Ta));
       }
     if(Ta<T && T<=1-Ta)
       {rr[0]=(1-2*Ta)*(1-2*Ta)*am/(pai*pai)*(1-cos(pai*(T-Ta)/(1-2*Ta)))
             +Va*(T-Ta)+Sa;
        rr[1]=(1-2*Ta)*am/pai*sin(pai*(T-Ta)/(1-2*Ta))+Va;
        rr[2]=am*cos(pai*(T-Ta)/(1-2*Ta));
       }
     if(1-Ta<T)
       {rr[0]=2*Ta*Va/pai*(cos(pai*(T-1+Ta)/(2*Ta))-1)
             +Va*(T-1+Ta)+(1-Sa);
        rr[1]=Va*(1-sin(pai*(T-1+Ta)/(2*Ta)));
        rr[2]=-am*cos(pai*(T-1+Ta)/(2*Ta));
       }
    }
   if(ch==5)   /* Gutmann */
    {rr[0]=T-15/(32*pai)*sin(2*pai*T)-1/(96*pai)*sin(6*pai*T);
     rr[1]=1-15.0/16*cos(2*pai*T)-1.0/16*cos(6*pai*T);
     rr[2]=15*pai/8*sin(2*pai*T)+3*pai/8*sin(6*pai*T);
    }
   if(ch==6)   /* modified constant velocity */
    {Ta=1.0/16; Tb=0.25;
     am=1/(2/pai)/Tb/((2-8/pai)*Ta+(4/pai-2)*Tb+1);
     Va=2*Ta*am/pai;  Sa=Ta*Va-2*Ta*Va/pai;
     Vb=2*Tb*am/pai;  Sb=4*(Tb-Ta)*(Tb-Ta)*am/(pai*pai)+Va*(Tb-Ta)+Sa;
     if(T<=Ta)
       {rr[0]=Va*T-2*Ta*Va/pai*sin(pai*T/(2*Ta));
        rr[1]=Va*(1-cos(pai*T/(2*Ta)));
        rr[2]=am*sin(pai*T/(2*Ta));
       }
     if(Ta<T && T<=Tb)
       {rr[0]=4*(Tb-Ta)*(Tb-Ta)*am/(pai*pai)*(1-cos(pai*(T-Ta)/(2*(Tb-Ta))))
             +Va*(T-Ta)+Sa;
        rr[1]=2*(Tb-Ta)*am/pai*sin(pai*(T-Ta)/(2*(Tb-Ta)))+Va;
        rr[2]=am*cos(pai*(T-Ta)/(2*(Tb-Ta)));
       }
     if(Tb<T && T<=1-Tb)
       {rr[0]=Vb*(T-Tb)+Sb;
        rr[1]=Vb;
        rr[2]=0;
       }
     if(1-Tb<T && T<=1-Ta)
       {t=T-1+Tb;
        rr[0]=4*(Tb-Ta)*(Tb-Ta)*am/(pai*pai)*sin(pai*t/(2*(Tb-Ta)))
             -2*(Tb-Ta)*am/pai*t+Vb*t+1-Sb;
        rr[1]=2*(Tb-Ta)*am/pai*cos(pai*t/(2*(Tb-Ta)))-2*(Tb-Ta)*am/pai+Vb;
        rr[2]=-am*sin(pai*t/(2*(Tb-Ta)));
       }
     if(1-Ta<T)
       {rr[0]=2*Ta*Va/pai*(cos(pai*(T-1+Ta)/(2*Ta))-1)+Va*(T-1+Ta)+1-Sa;
        rr[1]=-Va*sin(pai*(T-1+Ta)/(2*Ta))+Va;
        rr[2]=-am*cos(pai*(T-1+Ta)/(2*Ta));
       }
    }
   if(ch==7)   /* 2 interpoints */
    {Va=(Sb-Sa)/(Tb-Ta);
     if(T<=Ta)
       {rr[0]=Va/2*(T-sin(pai*T/Ta)*Ta/pai)
             +(Sa/Ta-Va/2)*(T-sin(pai2*T/Ta)*Ta/pai2);
        rr[1]=Va/2*(1-cos(pai*T/Ta))
             +(Sa/Ta-Va/2)*(1-cos(pai2*T/Ta));
        rr[2]=pai*Va/(2*Ta)*sin(pai*T/Ta)
             +(Sa/Ta-Va/2)*pai2/Ta*sin(pai2*T/Ta);
       }
     if(Ta<T && T<=Tb)
       {rr[0]=Sa+Va*(T-Ta);
        rr[1]=Va;
        rr[2]=0;
       }
     if(Tb<T)
       {t=1-T;
        rr[0]=1-Va/2*(t-sin(pai*t/(1-Tb))*(1-Tb)/pai)
            -((1-Sb)/(1-Tb)-Va/2)*(t-sin(pai2*t/(1-Tb))*(1-Tb)/pai2);
        rr[1]=Va/2*(1-cos(pai*t/(1-Tb)))
            +((1-Sb)/(1-Tb)-Va/2)*(1-cos(pai2*t/(1-Tb)));
        rr[2]=-pai*Va/(2*(1-Tb))*sin(pai*t/(1-Tb))
             -((1-Sb)/(1-Tb)-Va/2)*pai2/(1-Tb)*sin(pai2*t/(1-Tb));
       }
    }
  }
/* -------------------------------------------------------------------- */
points()
     {if(d2==0) {circle(Ta,Sa,0.015,d2);  circle(Tb,Sb,0.015,d2);}
      if(d2==1) {circle(Ta,Va,0.015,d2);  circle(Tb,Va,0.015,d2);}
      if(d2==2) {circle(Ta,0.,0.015,d2);  circle(Tb,0.,0.015,d2);}
     }
/* -------------------------------------------------------------------- */
main()
  {int i,j,k;
   FILE *fp[10];  
   _setvideomode(_98RESS8COLOR);
   /*_setactivepage(0);*/	/*cleardevice();*/
   /*_setactivepage(1);*/	/*cleardevice();*/
   dth=1.0/n;
p1:_clearscreen(_GCLEARSCREEN);   _setcolor(6);
   printf("\nCam curve");
   printf("\nChoose cam curve(follower lift curve.");
   printf("\n0:parabolic   ");
   printf("\n1:sine curve      2:cycloid     3:modified trapezoid  ");
   printf("\n4:modified sine   5:Gutmann     6:modified const vel  ");
   printf("\n7:difine 2 intermittent points  8<=:stop           ");
   scanf("%d",&d1);   if(d1>=8) goto end;
   if(d1==7)
     {printf("\nPut interpoints (0 - 1) A(Ta,Sa) and B(Tb,Sb)=");
      scanf("%f,%f,%f,%f",&Ta,&Sa,&Tb,&Sb);
      axis(2);      circle(Ta,Sa,0.015,0);  circle(Tb,Sb,0.015,0);
     }
p2:printf("\nDraw which? 0:Y(T), 1:V(T), 2:A(T) ");
   scanf("%d",&d2);
   _clearscreen(_GCLEARSCREEN);
   if(d2==0) axis(d2);   if(d2==1) axisv(d2);   if(d2==2) axisa(d2);
   fp[d1]=fopen(fname[d1],"wt");   fprintf(fp[d1],"%3d\n",n);
   if(d1==7)  {fprintf(fp[d1],"%8.5f %8.5f %8.5f %8.5f\n",Ta,Sa,Tb,Sb);
               points();}
/*
   printf("\nT=       Y(T)=      V(T)=        A(T)=");
*/
   th[0]=0;   F(d1, 0.0, lift[0]);
   fprintf(fp[d1],"%8.5f %8.5f %8.5f\n",lift[0][0],lift[0][1],lift[0][2]);
/*
printf("\n%6.3f %8.5f %8.5f %8.5f",th[0],lift[0][0],lift[0][1],lift[0][2]);
*/
   for(i=1;i<=n;i++)
     {th[i]=dth*i;
      F(d1,th[i],lift[i]);  /* lift[][0]=y; lift[][1]=v; lift[][2]=a */
      fprintf(fp[d1],"%8.5f %8.5f %8.5f\n",lift[i][0],lift[i][1],lift[i][2]);
      line(th[i-1],lift[i-1][d2],th[i],lift[i][d2],d2);
/*
printf("\n%6.3f %8.5f %8.5f %8.5f",th[i],lift[i][0],lift[i][1],lift[i][2]);
*/
      getch();
     }
   if(d1==7)  points();
   fclose(fp[d1]);
p3:printf("\nOther curve?  0:Y(T), 1:V(T), 2:A(T), 3:no  ");
   scanf("%d",&d2);
   if(d2>=3)  goto p5;
   _clearscreen(_GCLEARSCREEN);
   if(d2==0)  axis(d2);    if(d2==1)  axisv(d2);    if(d2==2)  axisa(d2);
   if(d1==7)  points();
   for(i=1;i<=n;i++)   line(th[i-1],lift[i-1][d2],th[i],lift[i][d2],d2);
   goto p3;
p5:printf("\nOther curve? 1:yes  0:no  ");  d1=getch();
   if(d1!='0')  goto p1;
end:;
  }
