/* Motion analysis of cam mechanism             1997.1.10*/
/* */
/* */
#include <math.h>
#include <stdio.h>
#include <dos.h>
#include <conio.h>
#include <graph.h>
char fname[10][32]={"curv0", "curv1", "curv2", "curv3", "curv4"
                   ,"curv5","curv6","curv7"},
     pname[10][32]={"profil0", "profil1", "profil2", "profil3","profil4", 
                    "profil5","profil6","profil7"};
float kx=80,ky=-80,x00=200,y00=200,pai=3.141593e0,pai2=6.283185e0
      ,pai4=1.256637e0,zero=0, X0=2,Y0=1;
float th[301],lift[301][3],rr[2],r[301],beta[301],dth
     ,rg,h=0.5,thm,am,c1,c2,H,Ta,Sa,Tb,Sb;
int n=96,d1;
float x,y;
char ch;
line(x1,y1,x2,y2) float x1,y1,x2,y2;
  {int p1,q1,p2,q2;
   p1=x00+kx*x1;   p2=x00+kx*x2;
   q1=y00+ky*y1;   q2=y00+ky*y2;
   _moveto(p1,q1);    _lineto(p2,q2);
  }
circle(x,y,r)  float x,y,r;
  {int p1,q1,p2,q2;
   p1=x00+kx*(x+r);   q1=y00+ky*(y+r);
   p2=x00+kx*(x-r);   q2=y00+ky*(y-r);
   _ellipse(_GBORDER,p1,q1,p2,q2);
  }
/* ----------------------------------------------------------------------- */
P(th,lift,rr)  float th,lift[],rr[];  /* lift[]=(Y,V,A),  rr[]=(r,beta) */
  {float y,v,al;
   rr[0]=sqrt((rg+lift[0])*(rg+lift[0])+lift[1]*lift[1]);
   al=atan2(lift[1]/rr[0], (rg+lift[0])/rr[0]);
   rr[1]=al+th;
  }
profile(m) int m;
  {float x1,y1,x2,y2;
   int j;
   x1=rg*sin(th[m]);   y1=rg*cos(th[m]);
   for(j=1;j<=m;j++)
     {x2=r[j]*sin(th[m]-beta[j]);
      y2=r[j]*cos(th[m]-beta[j]);
      line(x1,y1,x2,y2);
      x1=x2; y1=y2;
     }
  }
profile_whole(m) int m;
  {float x1,y1,x2,y2;
   int j;
   x1=rg*sin(th[m]);   y1=rg*cos(th[m]);
   for(j=0;j<=3*n;j++)
     {x2=r[j]*sin(th[m]-beta[j]);
      y2=r[j]*cos(th[m]-beta[j]);
      line(x1,y1,x2,y2);
      x1=x2; y1=y2;
     }
  }
follower(i) int i;
  {float h;
   h=rg+lift[i][0];
   line(-1.0,h,1.0,h);
   line(-1.0,h+0.2,1.0,h+0.2);
   line(-1.0,h,-1.0,h+0.2);
   line( 1.0,h, 1.0,h+0.2);
   line( 0.1,h+0.2, 0.1,h+1.0);
   line(-0.1,h+0.2,-0.1,h+1.0);
  }
axis()
  {line(X0,Y0, X0+2,Y0);   line(X0,Y0, X0,Y0+0.6);}
curve(i)
  {int j;  float x1,y1,x2,y2,dx;
   dx=2.0/(3*n);   x1=0; y1=0;
   for(j=1; j<=i;j++)
     {x2=dx*j;      y2=lift[j][0];
      line(X0+x1, Y0+y1, X0+x2, Y0+y2);      x1=x2; y1=y2;
     }
  }
/* -------------------------------------------------------------------- */
main()
  {int i,j,k;
   FILE *fp,*fc;
   _setvideomode(_98RESS8COLOR);
   /*_setactivepage(0);*/	/*cleardevice();*/
   /*_setactivepage(1);*/	/*cleardevice();*/
   _clearscreen(_GCLEARSCREEN);   _setcolor(6);
p1:printf("\nCam profile generation by flat follower");
   thm=pai2/3;
   printf("\nChoose cam curve(follower lift curve.");
   printf("\n0:parabolic     ");
   printf("\n1:sine curve      2:cycloid    3:modified trapezoid  ");
   printf("\n4:modified sine   5:Gutmann    6:modified const vel. ");
   printf("\n7:2-intermittent points  ");
   scanf("%d",&d1);
   rg=1;
   fc=fopen(fname[d1],"rt");   fscanf(fc,"%d",&n);
   fp=fopen(pname[d1],"wt");   fprintf(fp,"%d",3*n);
   if(d1==7)  {fscanf(fc,"%f %f %f %f",&Ta,&Sa,&Tb,&Sb);
               fprintf(fp,"%f %f %f %f\n",Ta,Sa,Tb,Sb);}
   dth=thm/n;
   for(i=0;i<=n;i++)
     {_clearscreen(_GCLEARSCREEN);
      th[i]=dth*i;
      fscanf(fc,"%f %f %f",&lift[i][0],&lift[i][1],&lift[i][2]);
      lift[i][0]=h*lift[i][0];
      lift[i][1]=h*lift[i][1]/thm;
      axis();  curve(i);
printf("\nth=%8.5f,Y=%8.5f, V=%8.5f",th[i],lift[i][0],lift[i][1]);
      P(th[i],lift[i],rr);  /* lift[i][]=(Y,V,A) rr[]=(r,beta) */
printf("\nrr[]=(%8.5f, %8.5f)",rr[0],rr[1]);
      r[i]=rr[0];
      beta[i]=rr[1];
      fprintf(fp,"%8.5f  %8.5f \n",r[i],beta[i]);
      circle(zero,zero,0.05);      circle(zero,zero,rg);
      x=rg*cos(th[i]);      y=rg*sin(th[i]);
      line(-x,y,x,-y);      line(y,x,-y,-x);
      if(i!=0) profile(i);  follower(i);
      circle(r[i]*sin(th[i]-beta[i]),r[i]*cos(th[i]-beta[i]),0.025);
      getch();
     }
/*
for(i=0;i<=n;i++)
printf("\nth=%8.5f,Y=%8.5f, V=%8.5f",th[i],lift[i][0],lift[i][1]);
*/
   fclose(fc);
   dth=(2*pai-2*thm)/n;
   for(i=1;i<=n;i++)
     {_clearscreen(_GCLEARSCREEN);
      th[n+i]=thm+dth*i;
      lift[n+i][0]=h;
      lift[n+i][1]=0;
      axis();   curve(n+i);
      r[n+i]=rg+h;
      beta[n+i]=th[n+i];
      fprintf(fp,"%8.5f %8.5f \n",r[n+i],beta[n+i]);
      circle(zero,zero,0.05);      circle(zero,zero,rg);
      x=rg*cos(th[n+i]);      y=rg*sin(th[n+i]);
      line(-x,y,x,-y);      line(y,x,-y,-x);
      if(i!=0) profile(n+i);  follower(n+i);
      circle(0.0, r[n+i], 0.025);
      getch();
     }
   dth=thm/n;
   for(i=0;i<=n;i++)
     {_clearscreen(_GCLEARSCREEN);
      th[2*n+i]=2*pai-thm+dth*i;
      lift[2*n+i][0]=lift[n-i][0];
      lift[2*n+i][1]=-lift[n-i][1];
      axis();  curve(2*n+i);
      P(th[2*n+i],lift[2*n+i],rr);  /* lift[][0]=Y; lift[][1]=V; lift[][2]=A */
                      /* rr[0]=r,     rr[1]=beta */
      r[2*n+i]=rr[0];
      beta[2*n+i]=rr[1];
      fprintf(fp,"%8.5f %8.5f \n",r[2*n+i],beta[2*n+i]);
      circle(zero,zero,0.05);      circle(zero,zero,rg);
      x=rg*cos(th[2*n+i]);      y=rg*sin(th[2*n+i]);
      line(-x,y,x,-y);      line(y,x,-y,-x);
      if(i!=0) profile(2*n+i);  follower(2*n+i);
      circle(r[2*n+i]*sin(th[2*n+i]-beta[2*n+i]),
             r[2*n+i]*cos(th[2*n+i]-beta[2*n+i]), 0.025);
      getch();
     }
   fclose(fp);
/*
for(i=0;i<=n;i++)
printf("\nth=%8.5f,Y=%8.5f,V=%8.5f",th[2*n+i],lift[2*n+i][0],lift[2*n+i][1]);
*/
p3:for(i=0;i<=3*n;i++)
     {_clearscreen(_GCLEARSCREEN);
      axis();  curve(3*n);   circle(X0+2*i/(3.0*n), Y0+lift[i][0], 0.02);
      circle(zero,zero,0.05);      circle(zero,zero,rg);
      x=rg*cos(th[i]);      y=rg*sin(th[i]);
      line(-x,y,x,-y);      line(y,x,-y,-x);
      profile_whole(i);  follower(i);
      circle(r[i]*sin(th[i]-beta[i]),
             r[i]*cos(th[i]-beta[i]), 0.025);   getch();
     }
   printf("\ndisplay again?  1:yes    0:no  ");   ch=getch();
   if(ch!='0')  goto p3;
   printf("\nOther cam curve?  1:yes  0:no  ");   ch=getch();
   if(ch!='0')  goto p1;
  }
