/* vibration analysis of cam mechanism             1997.1.14*/
#include <math.h>
#include <stdio.h>
#include <dos.h>
#include <conio.h>
#include <graph.h>
float kx=80,ky=-80,x00=200,y00=300,pai=3.141593e0,pai2=6.283185e0
      ,pai4=1.256637e1,zero=0, X0=2,Y0=1;
float th[301],lift[301][3],rr[2],r[301],beta[301],vib[301][2],dth
     ,rg=1,h=0.5,lengthf=1.5,thm,am,c1,c2,H,Ta,Sa,Va,Tb,Sb,Vb,OMEGA2,T,amp;
int n=96,d1;
float x,y,t,dt;
char ch;
line(x1,y1,x2,y2) float x1,y1,x2,y2;
  {int p1,q1,p2,q2;
   p1=x00+kx*x1;   p2=x00+kx*x2;
   q1=y00+ky*y1;   q2=y00+ky*y2;
   _moveto(p1,q1);    _lineto(p2,q2);
  }
rect(x1,y1,x2,y2) float x1,y1,x2,y2;
  {int p1,q1,p2,q2;
   p1=x00+kx*x1;   p2=x00+kx*x2;
   q1=y00+ky*y1;   q2=y00+ky*y2;
   _rectangle(_GBORDER,p1,q1,p2,q2);
  }
circle(x,y,r)  float x,y,r;
  {int p1,q1,p2,q2;
   p1=x00+kx*(x+r);   q1=y00+ky*(y+r);
   p2=x00+kx*(x-r);   q2=y00+ky*(y-r);
   _ellipse(_GBORDER,p1,q1,p2,q2);
  }
/* ----------------------------------------------------------------------- */
P(th,lift,rr)  float th,lift[],rr[];  /* lift[]=(Y,V,A),  rr[]=(r,beta) */
  {float y,v,al;
   y=h*lift[0];  v=h*lift[1]/thm;
   rr[0]=sqrt((rg+y)*(rg+y)+v*v);
   al=atan2(v/rr[0], (rg+y)/rr[0]);
   rr[1]=al+th;
  }
profile(m) int m;
  {float x1,y1,x2,y2;
   int j;
   x1=rg*sin(th[m]);   y1=rg*cos(th[m]);
   for(j=1;j<=m;j++)
     {x2=r[j]*sin(th[m]-beta[j]);
      y2=r[j]*cos(th[m]-beta[j]);
      line(x1,y1,x2,y2);
      x1=x2; y1=y2;
     }
  }
profile_whole(m) int m;
  {float x1,y1,x2,y2;
   int j;
   x1=rg*sin(th[m]);   y1=rg*cos(th[m]);
   for(j=0;j<=3*n;j++)
     {x2=r[j]*sin(th[m]-beta[j]);
      y2=r[j]*cos(th[m]-beta[j]);
      line(x1,y1,x2,y2);
      x1=x2; y1=y2;
     }
  }
follower(i) int i;
  {float H;
   H=rg+h*lift[i][0];
   rect(-1.0,H,     1.0,H+0.2);
   rect(-0.1,H+0.2, 0.1,H+0.5);
  }
mass(i) int i;
  {float y,p,dp,x1,y1,x2,y2;  int j;
   y=rg+lengthf+h*lift[i][0];
   _setcolor(3); rect(-0.3,y, 0.3,y+0.3); _setcolor(6);
   y=y+5*vib[i][0];
   rect(-0.3,y, 0.3,y+0.3);
   p=5*vib[i][0]+lengthf-0.5;
   dp=p/10;
   x1=0; y1=rg+h*lift[i][0]+0.5;   x2=0.25; y2=y1+dp;
   line(x1,y1,x2,y2);
   for(j=1;j<5;j++)
     {x1=x2; y1=y2;
      x2=-x2; y2=y2+dp+dp;
      line(x1,y1,x2,y2);
     }
   x1=x2; y1=y2;  x2=0;  y2=y;  line(x1,y1,x2,y2);
  }
/* ------------------------------------------------------------------- */
axis()
  {line(X0,Y0, X0+3,Y0);        line(X0,Y0, X0,Y0+1.2);
   line(X0+1,Y0,X0+1,Y0+1.2);   line(X0+2,Y0,X0+2,Y0+1.2);}
curve(i)
  {int j;  float x1,y1,x2,y2,dx;
   dx=1.0/n;   x1=0; y1=0;
   for(j=1; j<=i;j++)
     {x2=dx*j;      y2=lift[j][0];
      if(j>=n) y2=1;
      line(X0+x1, Y0+y1, X0+x2, Y0+y2);      x1=x2; y1=y2;
     }
  }

/* ----------------------------------------------------------------------- */
F(ch,T,rr) int ch; float T,rr[];  /* rr[]=(Y,V,A) */
  {float H,t;
   if(ch==0)   /* parabolic */
    {if(T<=0.5) {rr[0]=2*T*T; rr[1]=4*T;  rr[2]=4;}
     if(0.5<T)  {rr[0]=T*(4-2*T)-1; rr[1]=4*(1-T);  rr[2]=-4;}
    }
   if(ch==1)   /* sine */
    {rr[0]=0.5*(1-cos(pai*T));
     rr[1]=pai/2*sin(pai*T);  rr[2]=pai*pai/2*cos(pai*T);
    }
   if(ch==2)   /* cycloid */
    {rr[0]=(T-sin(pai2*T)/pai2);
     rr[1]= 1-cos(pai2*T);  rr[2]=pai2*sin(pai2*T);
    }
   if(ch==3)   /* modified trapezoid */
    {Ta=0.125;  am=1/(0.25-(1-2/pai)*Ta);
     if(T<=Ta)
       {H=am/pai4;        rr[0]=H*(T-sin(pai4*T)/pai4);
        rr[1]=H*(1-cos(pai4*T));  rr[2]=am*sin(pai4*T); }
     if(Ta<T && T<=3*Ta)
        {c1=1/pai4;  c2=(1-2/pai)/(32*pai);
         rr[0]=am*((T-Ta)*(T-Ta)/2+c1*(T-Ta)+c2);
         rr[1]=am*((T-Ta)+c1);   rr[2]=am;              }
     if(3*Ta<T && T<=5*Ta)
        {c1=0.5-(2-2/pai)/8; c2=0.125-(1-1/pai)/8+(2-2/pai)/64;
         rr[0]=am*(sin(pai4*(T-0.5))/(pai4*pai4)+c1*(T-0.5+Ta)+c2);
         rr[1]=am*(cos(pai4*(T-0.5))/pai4+c1);  rr[2]=-am*sin(pai4*(T-0.5));}
     if(5*Ta<T && T<=7*Ta)
        {t=1-T; c1=1/pai4; c2=(1-2/pai)/(32*pai);
         rr[0]=1-am*((t-Ta)*(t-Ta)/2+c1*(t-Ta)+c2);
         rr[1]=am*((t-Ta)+c1);   rr[2]=-am;             }
     if(7*Ta<T && T<1)
       {H=am/pai4;  t=1-T;
        rr[0]=1-H*(t-sin(pai4*t)/pai4);
        rr[1]=H*(1-cos(pai4*t));  rr[2]=-am*sin(pai4*t);}
    }
   if(ch==4)   /* modified sine */
    {Ta=0.125;       am=1/(2*Ta/pai+(2-8*Ta)/(pai*pai));
     Va=2*Ta*am/pai; Sa=2*Ta*Ta*am/pai*(1-2/pai);
     if(T<=Ta)
       {rr[0]=Va*T-2*Ta*Va/pai*sin(pai*T/(2*Ta));
        rr[1]=Va*(1-cos(pai*T/(2*Ta)));   rr[2]=am*sin(pai*T/(2*Ta)); }
     if(Ta<T && T<=1-Ta)
       {rr[0]=(1-2*Ta)*(1-2*Ta)*am/(pai*pai)*(1-cos(pai*(T-Ta)/(1-2*Ta)))
             +Va*(T-Ta)+Sa;
        rr[1]=(1-2*Ta)*am/pai*sin(pai*(T-Ta)/(1-2*Ta))+Va;
        rr[2]=am*cos(pai*(T-Ta)/(1-2*Ta));              }
     if(1-Ta<T && T<1)
       {rr[0]=2*Ta*Va/pai*(cos(pai*(T-1+Ta)/(2*Ta))-1)
             +Va*(T-1+Ta)+(1-Sa);
        rr[1]=Va*(1-sin(pai*(T-1+Ta)/(2*Ta)));
        rr[2]=-am*cos(pai*(T-1+Ta)/(2*Ta));             }
    }
   if(ch==5)   /* Gutmann */
    {rr[0]=T-15/(32*pai)*sin(2*pai*T)-1/(96*pai)*sin(6*pai*T);
     rr[1]=1-15.0/16*cos(2*pai*T)-1.0/16*cos(6*pai*T);
     rr[2]=15*pai/8*sin(2*pai*T)+3*pai/8*sin(6*pai*T);
    }
   if(ch==6)   /* modified constant velocity */
    {Ta=1.0/16; Tb=0.25;
     am=1/(2/pai)/Tb/((2-8/pai)*Ta+(4/pai-2)*Tb+1);
     Va=2*Ta*am/pai;  Sa=Ta*Va-2*Ta*Va/pai;
     Vb=2*Tb*am/pai;  Sb=4*(Tb-Ta)*(Tb-Ta)*am/(pai*pai)+Va*(Tb-Ta)+Sa;
     if(T<=Ta)
       {rr[0]=Va*T-2*Ta*Va/pai*sin(pai*T/(2*Ta));
        rr[1]=Va*(1-cos(pai*T/(2*Ta)));    rr[2]=am*sin(pai*T/(2*Ta)); }
     if(Ta<T && T<=Tb)
       {rr[0]=4*(Tb-Ta)*(Tb-Ta)*am/(pai*pai)*(1-cos(pai*(T-Ta)/(2*(Tb-Ta))))
             +Va*(T-Ta)+Sa;
        rr[1]=2*(Tb-Ta)*am/pai*sin(pai*(T-Ta)/(2*(Tb-Ta)))+Va;
        rr[2]=am*cos(pai*(T-Ta)/(2*(Tb-Ta)));           }
     if(Tb<T && T<=1-Tb)
       {rr[0]=Vb*(T-Tb)+Sb;      rr[1]=Vb;       rr[2]=0; }
     if(1-Tb<T && T<=1-Ta)
       {t=T-1+Tb;
        rr[0]=4*(Tb-Ta)*(Tb-Ta)*am/(pai*pai)*sin(pai*t/(2*(Tb-Ta)))
             -2*(Tb-Ta)*am/pai*t+Vb*t+1-Sb;
        rr[1]=2*(Tb-Ta)*am/pai*cos(pai*t/(2*(Tb-Ta)))-2*(Tb-Ta)*am/pai+Vb;
        rr[2]=-am*sin(pai*t/(2*(Tb-Ta)));               }
     if(1-Ta<T && T<1)
       {rr[0]=2*Ta*Va/pai*(cos(pai*(T-1+Ta)/(2*Ta))-1)+Va*(T-1+Ta)+1-Sa;
        rr[1]=-Va*sin(pai*(T-1+Ta)/(2*Ta))+Va;
        rr[2]=-am*cos(pai*(T-1+Ta)/(2*Ta));             }
    }
   if(ch==7)   /* 2 interpoints */
    {Va=(Sb-Sa)/(Tb-Ta);
     if(T<=Ta)
       {rr[0]=Va/2*(T-sin(pai*T/Ta)*Ta/pai)
             +(Sa/Ta-Va/2)*(T-sin(2*pai*T/Ta)*Ta/(2*pai));
        rr[1]=Va/2*(1-cos(pai*T/Ta))+(Sa/Ta-Va/2)*(1-cos(2*pai*T/Ta));
        rr[2]=pai*Va/(2*Ta)*sin(pai*T/Ta)
             +(Sa/Ta-Va/2)*2*pai/Ta*sin(2*pai*T/Ta);    }
     if(Ta<T && T<=Tb)
       {rr[0]=Sa+Va*(T-Ta);      rr[1]=Va;        rr[2]=0; }
     if(Tb<T && T<1)
       {t=1-T;
        rr[0]=1-Va/2*(t-sin(pai*t/(1-Tb))*(1-Tb)/pai)
            -((1-Sb)/(1-Tb)-Va/2)*(t-sin(2*pai*t/(1-Tb))*(1-Tb)/(2*pai));
        rr[1]=Va/2*(1-cos(pai*t/(1-Tb)))
            +((1-Sb)/(1-Tb)-Va/2)*(1-cos(2*pai*t/(1-Tb)));
        rr[2]=-pai*Va/(2*(1-Tb))*sin(pai*t/(1-Tb))
             -((1-Sb)/(1-Tb)-Va/2)*2*pai/(1-Tb)*sin(2*pai*t/(1-Tb));}
    }
   if(1<=T) {rr[0]=1; rr[1]=rr[2]=0;}
  }
float f(i,t,y)  int i;  float t,y[];
  {float z;
   if(i==0) {z=y[1];  return z;}
   if(i==1) {F(d1,t,rr);  z=-OMEGA2*y[0]-rr[2];  return z;}
  }
/* -------------------------------------------------------------------- */
points(d2)   int d2;
     {if(d2==0) {circle(Ta,Sa,0.02,d2);  circle(Tb,Sb,0.02,d2);}
      if(d2==1) {circle(Ta,Va,0.02,d2);  circle(Tb,Va,0.02,d2);}
      if(d2==2) {circle(Ta,0.,0.02,d2);  circle(Tb,0.,0.02,d2);}
     }
/* rkg(t,dt,y0,y4,n) ------------------------------------------------ */
/* t,dt : time, incremental time */
/* y0,y4 : initial state(t=t), final state(t=t+dt) */
/* n : n equations (<10) */
/* difine equation f(i,t,y) : i-th equation (i=0; i<n)*/
rkg(t,dt,y0,y4,n) float t,dt,y0[],y4[];      int n;
  {float a1=0.292893219,a2=1.70710678,a3=0.16666667
        ,y1[10],y2[10],y3[10],k0[10],k1[10],k2[10],k3[10]
        ,r1[10],r2[10],r3[10],r4[10],q1[10],q2[10],q3[10],q4[10];
   int i;
   for(i=0;i<n;i++)
      {k0[i]=dt*f(i,t,y0);        r1[i]=0.5*k0[i];
       y1[i]=y0[i]+r1[i];         q1[i]=3*r1[i]-0.5*k0[i];
      }
   for(i=0;i<n;i++)
      {k1[i]=dt*f(i,t+0.5*dt,y1); r2[i]=a1*(k1[i]-q1[i]);
       y2[i]=y1[i]+r2[i];         q2[i]=q1[i]+3*r2[i]-a1*k1[i];
      }
   for(i=0;i<n;i++)
      {k2[i]=dt*f(i,t+0.5*dt,y2); r3[i]=a2*(k2[i]-q2[i]);
       y3[i]=y2[i]+r3[i];         q3[i]=q2[i]+3*r3[i]-a2*k2[i];
      }
   for(i=0;i<n;i++)
      {k3[i]=dt*f(i,t+dt,y3);     r4[i]=a3*(k3[i]-2*q3[i]);
       y4[i]=y3[i]+r4[i];         q4[i]=q3[i]+3*r4[i]-0.5*k3[i];
      }
  }
/* -------------------------------------------------------------------- */
main()
  {int i,j,k;   float x1,y1,x2,y2,TT,t,dt,y0[2],y4[2],amp;
   _setvideomode(_98RESS8COLOR);
   /*_setactivepage(0);*/	/*cleardevice();*/
   /*_setactivepage(1);*/	/*cleardevice();*/
   _clearscreen(_GCLEARSCREEN);   _setcolor(6);
p1:printf("\nVibration of cam follower");
   thm=pai2/3;
   printf("\nChoose cam curve(follower lift curve.");
   printf("\n0:paraboloic  ");
   printf("\n1:sine curve      2:cycloid    3:modified trapezoid  ");
   printf("\n4:modified sine   5:Gutmann    6:modified const vel. ");
   printf("\n7:2-intermittent points path ");
   scanf("%d",&d1);
   rg=1;
   if(d1==7) {printf("\nInput Ta,Sa,Tb,Sb");
              scanf("%f,%f,%f,%f",&Ta,&Sa,&Tb,&Sb);}
   n=96;
   dth=thm/n;  /* thm=2*pai/3  */
   for(i=0;i<=n;i++)
     {th[i]=dth*i;   T=th[i]/thm;
      F(d1,T,lift[i]);
      P(th[i],lift[i],rr);       /* lift[]=(Y,V,A),  rr[]=(r,beta) */
      r[i]=rr[0];    beta[i]=rr[1];
     }
   dth=(2*pai-2*thm)/n;
   for(i=1;i<=n;i++)
     {th[n+i]=thm+dth*i;
      lift[n+i][0]=1;
      lift[n+i][1]=lift[n+i][2]=0;
      r[n+i]=rg+h;   beta[n+i]=th[n+i];
     }
   dth=thm/n;
   for(i=1;i<=n;i++)
     {th[2*n+i]=2*pai-thm+dth*i;
      lift[2*n+i][0]=1;     lift[2*n+i][1]=lift[2*n+i][2]=0;
      r[2*n+i]=r[n-i];  beta[2*n+i]=2*pai-beta[n-i];
     }
p3:printf("\nInput t0/th=");  scanf("%f",&TT);  printf("\nth/t0=%6.3f",TT);
   OMEGA2=pai2*TT;  OMEGA2=OMEGA2*OMEGA2;
   t=y0[0]=y0[1]=amp=0;  dt=1.0/n;
   for(i=0;i<=3*n;i++)
     {_clearscreen(_GCLEARSCREEN);
      axis();  curve(3*n);
      circle(X0+i/(1.0*n), Y0+lift[i][0], 0.02);
      circle(zero,zero,0.05);      circle(zero,zero,rg);
      x=rg*cos(th[i]);      y=rg*sin(th[i]);
      line(-x,y,x,-y);      line(y,x,-y,-x);
      if(i<3*n/2)  {profile_whole(i);  follower(i);
                    circle(r[i]*sin(th[i]-beta[i]),
                           r[i]*cos(th[i]-beta[i]), 0.025);}
      else         {j=1.5*n; profile_whole(j); follower(j);
                    circle(0.0, rg+h, 0.025);}
      /* --------------vibration calculation ---------------------- */
      if(i==0)    y4[0]=y4[1]=0;
      if(i!=0)   {t=t+dt;  y0[0]=y4[0]; y0[1]=y4[1];
                  rkg(t,dt,y0,y4,2);
                  vib[i][0]=y4[0];  vib[i][1]=y4[1];}
      if(n<=i && i<=2*n && amp<vib[i][0])  amp=vib[i][0];
      printf("\ncurve=%d ,t0/th=%6.3f, amplitude=%12.4e",d1,TT,amp);
      printf("\n0<t<2n : 5, 2n<t : 50-times display");
      mass(i);
      _setcolor(3);
      x1=X0;  y1=Y0;
      for(j=0;j<=i;j++)
         {x2=X0+j/(1.0*n);  y2=Y0+lift[j][0]+5*vib[j][0];
          if(j>=2*n && amp<1.0e-2) y2=Y0+lift[j][0]+50*vib[j][0];
          line(x1,y1,x2,y2);    x1=x2; y1=y2;}
      _setcolor(6);     k=getch();  if(k=='0') break;
     }
   printf("\nOther t0?  1:yes    0:no  ");   ch=getch();
   if(ch!='0')  goto p3;
   printf("\nOther cam curve?  1:yes  0:no  ");   ch=getch();
   if(ch!='0')  goto p1;
  }
